package question4;

import question3.BinaryTree;

/**
 * A binary heap implementation of Priority Queue.
 *  - It uses rank array representation.
 *  - It stores integers.
 *  - The "best" element is the smallest one.
 *  - It does not support "remove" operation!
 *  - Its capacity is fix and set at construction.
 */
public class PriorityQueue {
  protected Integer[] data;
  protected int numElements;

  /**
   * Construct an empty priority queue.
   * @param size of this priority queue.
   */
  public PriorityQueue(int size) {
    if (size > 0) {
      data = new Integer[size];
      numElements = 0;
    } else {
      throw new RuntimeException("Size must be > 0");
    }
  }

  /**
   * Insert a value.
   * @param value to insert.
   */
  public void insert(int value) {
    if (numElements < data.length) {
      data[++numElements] = value;
      swim(numElements);
    } else {
      throw new RuntimeException("The Priority Queue is full!");
    }
  }

  // Swim up operation.
  // Keep it as "protected".
  protected void swim(int index) {
    // TODO Implement me!
  }

  /**
   * Return best (smallest) value.
   * @return best value in the queue.
   */
  public int best() {
    if (!empty()) {
      return data[1];
    } else {
      throw new RuntimeException("The Priority Queue is empty!");
    }
  }

  /**
   * Check if no elements present.
   * @return True if queue is empty, false otherwise.
   */
  boolean empty() {
    return numElements == 0;
  }

  @Override
  public String toString() {
    return BinaryTree.toString(BinaryTree.toTree(this.data));
  }
}
