package question5;

import question3.Node;

public class BinarySearchTreeSln1 extends BinarySearchTree {
  @Override
  public boolean isValid(Node root) {
    return isValid(root, null, null);
  }

  // Idea of recursive method:
  //  Compare the node value with its upper and lower limits (if they are available).
  //  Repeats the same step recursively for left and right subtrees.
  //
  // The lower & upper limits depend on the ancestors.
  // For example, if you are a subtree to the left of your parent,
  //  who is to the right of your grandparent, then all the values in “you”
  //  are greater than the value of your grandparent and smaller than
  //  the value in your parent.
  private Boolean isValid(Node node, Integer lower, Integer upper) {
    if (node == null) {
      return true;
    }

    if (lower != null && node.data <= lower) {
      return false;
    }

    if (upper != null && node.data >= upper) {
      return false;
    }

    if (! isValid(node.right, node.data, upper)) {
      return false;
    }

    return isValid(node.left, lower, node.data);
  }
}
