package grade;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import question3.BinaryTree;
import question3.Node;
import question5.BinarySearchTree;
import question5.BinarySearchTreeSln1;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class BinarySearchTreeSln1Test {

  private BinarySearchTree bst;
  
  @BeforeEach
  void setUp() {
    bst = createUnit();
  }

  protected BinarySearchTree createUnit() {
    return new BinarySearchTreeSln1();
  }

  @Test
  @DisplayName("[Question 5] (1) empty tree is BST")
  void emptyTreeIsBst() {
    assertTrue(bst.isValid(null));
  }

  @Test
  @DisplayName("[Question 5] (2) single node is BST")
  void singleNodeIsBst() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 1});
    assertTrue(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (3) [1, _, 2] tree is BST")
  void twoNode_case1() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 1, null, 2});
    assertTrue(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (4) [2, 1, _] tree is BST")
  void twoNode_case2() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 2, 1, null});
    assertTrue(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (5) [2, _, 1] tree is not BST")
  void twoNode_case3() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 2, null, 1});
    assertFalse(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (6) [1, 2, _] tree is not BST")
  void twoNode_case4() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 1, 2, null});
    assertFalse(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (7) [2, 1, _, _, 3] tree is not BST")
  void threeNode_case1() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 2, 1, null, null, 3, null, null});
    assertFalse(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (8) [2, _, 3, _, _, 1] tree is not BST")
  void threeNode_case2() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 2, null, 3, null, null, 1, null});
    assertFalse(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (9) [1, _, 2, 3] tree is BST")
  void threeNode_case3() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 1, null, 2, null, null, null, 3});
    assertTrue(bst.isValid(tree));
  }

  @Test
  @DisplayName("[Question 5] (10) [3, 2, 1] tree is BST")
  void threeNode_case4() {
    Node tree = BinaryTree.toTree(new Integer[]{null, 3, 2, null, 1, null, null, null});
    assertTrue(bst.isValid(tree));
  }
}
